Overview | Package | Class | Use | Tree | Deprecated | Index | Help
|  | BEA Systems, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.bea.rfid.edge.api.workflow
Interface WorkflowManager

All Superinterfaces:
  com.connecterra.workflow.engine.api.WorkflowModuleManager

    public interface WorkflowManager

extends com.connecterra.workflow.engine.api.WorkflowModuleManager

Edge flow manager interface used by the edge server to define, reconfigure or delete edge flow modules.

This interface can also be used by modules to get to services that are commonly used by edge flow modules, like the ALE and ALEPC services.

WorkflowManager extends `com.connecterra.workflow.engine.api.WorkflowModuleManager` to make it easy to support legacy workflow modules.

Method Summary
`void` | `define(PluginConfig pluginConfig, PluginMeta pluginMeta, boolean redefine)` Interface to create or reconfigure a workflow module.
`AlarmClock` | `getAlarmClock()` Returns the `AlarmClock` to be used by workflow event processor.
`com.connecterra.ale.api.ALE` | `getALE()` Returns ALE implementation used in the edge server.
`com.connecterra.ale.api.ALEFactory` | `getALEFactory()` Returns an ALEFactory implementation that may be used by edge flow modules.
`com.connecterra.alepc.api.ALEPC` | `getALEPC()` Returns ALEPC implementation in the edge server.
`com.connecterra.alepc.api.ALEPCFactory` | `getALEPCFactory()` Returns an ALEPCFactory implementation that may be used by edge flow modules.
`List` | `getDynamicSet(PluginParameterConstraintDynamicSet setConstraint)` Gets the dynamic set defined by the input dynamic set constraint.
`int` | `getModuleEventsQueueSize()` Returns the event queue size for workflow module events.
`com.connecterra.notify.NotificationManager` | `getNotificationManager()` Returns the notification manager in edge server.
`com.connecterra.util.event.ThreadPoolScheduler` | `getScheduler()` Returns the `ThreadPoolScheduler` used for workflow event processing.
`Timer` | `getTimer()` An instance of `java.util.Timer` that may be used by edge flow modules or framework to schedule timer tasks.
`com.bea.rfid.edge.api.trigger.TriggerManager` | `getTriggerManager()` Returns reference to trigger manager in the edge server.
`WorkflowNamingService` | `getWorkflowNamingService()` Returns reference to the `WorkflowNamingService` in the edge flow engine.
`void` | `undefine(String name)` Undefines (deletes) a workflow module.

Methods inherited from interface com.connecterra.workflow.engine.api.WorkflowModuleManager
`define, getAlePCSerivce, getAleService, getWorkflowModuleEventCycleEventQueueSize, undefine`

Method Detail

### define

    void define(PluginConfig pluginConfig,
                PluginMeta pluginMeta,
                boolean redefine)
                throws PluginException

  Interface to create or reconfigure a workflow module.

  Parameters:
    `pluginConfig` - PluginConfig object containing the configurations for the module.
    `pluginMeta` - PluginMeta for the plugin config.
    `redefine` - Boolean value indicating if the module should be redefined if it already exists.
  Throws:
    `PluginException` - If there was an error defining the workflow module.

### undefine

    void undefine(String name)
                  throws PluginException

  Undefines (deletes) a workflow module.

  Parameters:
    `name` - The name of the workflow module that is to be undefined.
  Throws:
    `PluginException` - If there is an error undefining the workflow module.

### getDynamicSet

    List getDynamicSet(PluginParameterConstraintDynamicSet setConstraint)
                       throws PluginException

  Gets the dynamic set defined by the input dynamic set constraint.

  Parameters:
    `setConstraint` - The constraint to be used to calculate the dynamic set.
  Throws:
    `PluginException` - If an error occurs in the operation.

### getScheduler

    com.connecterra.util.event.ThreadPoolScheduler getScheduler()

  Returns the `ThreadPoolScheduler` used for workflow event processing.

  Specified by:
    `getScheduler` in interface `com.connecterra.workflow.engine.api.WorkflowModuleManager`
  Returns:
    `ThreadPoolScheduler` used for workflow event processing.

### getAlarmClock

    AlarmClock getAlarmClock()

  Returns the `AlarmClock` to be used by workflow event processor.

  Specified by:
    `getAlarmClock` in interface `com.connecterra.workflow.engine.api.WorkflowModuleManager`
  Returns:
    The `AlarmClock` used by the workflow event processor.

### getModuleEventsQueueSize

    int getModuleEventsQueueSize()

  Returns the event queue size for workflow module events. When the queue size exceeds this size, events will start getting dropped.

  Returns:
    The workflow modules' event queue size.

### getTriggerManager

    com.bea.rfid.edge.api.trigger.TriggerManager getTriggerManager()

  Returns reference to trigger manager in the edge server. This may be used by modules to get to trigger drivers.

  Returns:
    The trigger manager in the edge server.

### getNotificationManager

    com.connecterra.notify.NotificationManager getNotificationManager()

  Returns the notification manager in edge server. This may be used by modules to get to notification drivers.

  Specified by:
    `getNotificationManager` in interface `com.connecterra.workflow.engine.api.WorkflowModuleManager`
  Returns:
    The notification manager in the edge server.

### getALE

    com.connecterra.ale.api.ALE getALE()

  Returns ALE implementation used in the edge server.

  Returns:
    ALE implementation used in the edge server.

### getALEPC

    com.connecterra.alepc.api.ALEPC getALEPC()

  Returns ALEPC implementation in the edge server.

  Returns:
    ALEPC implementation in the edge server.

### getALEFactory

    com.connecterra.ale.api.ALEFactory getALEFactory()

  Returns an ALEFactory implementation that may be used by edge flow modules. This is provided for convenience and for efficiency, so that every module does not have to create its own instance of the factory.

### getALEPCFactory

    com.connecterra.alepc.api.ALEPCFactory getALEPCFactory()

  Returns an ALEPCFactory implementation that may be used by edge flow modules. This is provided for convenience and for efficiency, so that every module does not have to create its own instance of the factory.

  Specified by:
    `getALEPCFactory` in interface `com.connecterra.workflow.engine.api.WorkflowModuleManager`

### getWorkflowNamingService

    WorkflowNamingService getWorkflowNamingService()

  Returns reference to the `WorkflowNamingService` in the edge flow engine. This may be used by edge flow modules to look up resources registered with the naming service.

  Specified by:
    `getWorkflowNamingService` in interface `com.connecterra.workflow.engine.api.WorkflowModuleManager`
  Returns:
    `WorkflowNamingService` in the edge flow engine.

### getTimer

    Timer getTimer()

  An instance of `java.util.Timer` that may be used by edge flow modules or framework to schedule timer tasks. This is provided for convenience and for efficiency.

  Returns:
    An instance of `java.util.Timer` shared within the edge flow system.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Documentation is available at ${DOCSWEBROOT} Copyright 2007 BEA Systems Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD